// memo.cpp -- memorandum manager
// compiles with the -ml switch in Borland C++ 4.51
/*
NOTES -- a note card manager
 Copyright (C) 1996 KANSYS, Inc.
 This program is free software; you can redistribute it and/or 
 modify it under the terms of the GNU General Public License as 
 published by the Free Software Foundation; either version 2 of 
 the License, or (at your option) any later version.
 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 General Public License for more details.
 You should have received a copy of the GNU General Public License 
 along with this program; if not, write to the Free Software 
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 Author: Charles E. Hallenbeck, Ph.D.
 KanSys, Inc.
 4301 Wimbledon Terr. #2B
 Lawrence, KS 66047
 Telephone: 913-843-0351
*/
#include <constrea.h>
#include <fstream.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <dir.h>
#include <time.h>
#include <bios.h>
const int maxdecksize = 1000; // max entries in a file
const int maxheader = 60; // max chars in a header
const int bodysize = 20; // lines of text in a body
constream box1, box2, box3, box4;
struct line { line *n; char *t; };
struct ref { ref *n; int r; };
struct note { int id; char *hd; line *bd; ref *rf; };
unsigned char errors, changes; // yes or no
int former, current, decksize;
int seq[maxdecksize]; // sorting index
note deck [maxdecksize]; // array of entries
void getmemos (char *);
int showindex ();
int showrefs ();
void editnote ();
int editor (char *, char **);
void putmemos (char *, int);
void sortmemos ();
void drawscreen ();
void beep ();
void joinlines (char **, int, int);
int wordwrap (char **, int, int);
void redraw1 (char **, int, int);
void 
redraw2 (int);
void redraw3 (ref *, int, int);
int refcount (int);
void main (int argc, char **argv)
{ int a; char fn[MAXPATH];
if (argc==1) // get default file
{ strcpy (fn, *argv); *strrchr (fn, '.')=0; }
else strcpy (fn, *++argv);
getmemos (fn);
do { a=showindex ();
if (a=='8') putmemos (fn, 0);
else if (a=='9') putmemos (fn, 1); }
while (a!='9');
window (1, 1, 80, 25); clrscr(); } // end of main
/***/void getmemos (char *fn)
{ int a, b, c; char *p, buf[MAXPATH];
line *s, *t; ref *q, *r;
errors=changes=0; former=maxdecksize; current=decksize=0;
for (a=0; a<maxdecksize; a++) // initialize deck
{ deck[a].id=0; deck[a].hd=NULL; deck[a].bd=NULL; deck[a].rf=NULL; }
strlwr (fn); if ((p=strrchr (fn, '\\'))==NULL) p=fn;
if (strchr (p, '.')==NULL) strcat (p, ".nts");
else if (strstr (p, ".nts")==NULL)
{ cout << "Invalid file name \"" << fn << '"' << endl;
cout << "Use only the .nts extension." << endl; exit(0); }
drawscreen(); directvideo=0;
ifstream fin (fn); if (fin.fail ()) // no file
{ box4 << endl << "New file (unable to open " << fn << ')'; return; }
a=0; fin.getline (buf, MAXPATH);
if (strcmp (buf, "<memos>")) // non-0 means trouble
{ box4 << endl << "Bad file format #1: " << buf; errors=2; return; }
do { fin.getline (buf, MAXPATH);
if (!deck[a].id && !strncmp (buf, "<memo#", 6)) // start of note
{ deck[a].id=atoi(buf+6);
if ((p=strchr (buf+6, '>'))==NULL) // null means trouble
{ box4 << endl << "Bad file format #2: " << buf; errors=2; return; }
b=strlen(p+1); if (b) // optional header text
{ deck[a].hd = new char [b+1]; strcpy (deck[a].hd, p+1); }
continue; } // end of header line
if (strcmp (buf, "</memos>") && strncmp (buf, "</memo#", 7)
 && strcmp (buf, "<refs>")) // must be body text
{ b=strlen(buf); if (b) { t = new line; t->n=NULL;
t->t = new char [b+1]; strcpy (t->t, buf);
if (deck[a].bd==NULL) deck[a].bd=t;
else { s=deck[a].bd; while (s->n!=NULL) s=s->n; s->n=t; } }
continue; } // end of line of body text
if (!strcmp (buf, "<refs>")) // start of ref list
{ fin.getline (buf, MAXPATH); while (strncmp (buf, "</memo#", 7))
{ r = new ref; r->r=atoi(buf); r->n=deck[a].rf; deck[a].rf=r;
fin.getline (buf, MAXPATH); } } // end of ref list
if (!strncmp (buf, "</memo#", 7)) // end of note
{ if (deck[a].id != atoi (buf+7) || strchr (buf+7, '>')==NULL)
{ box4 << endl << "Bad file format #3: " << buf; errors=2; return; }
a++; } } while (strcmp (buf, "</memos>"));
decksize=a; p=strrchr (fn, '\\');
box4 << endl << "File " << (p==NULL? fn: p+1) 
<< ": " << coreleft()/1024 << "k free.";
do { for (a=0, c=0; a<decksize-1; a++)  // check for duplicates
{ for (b=a+1; b<decksize; b++) if (deck[a].id==deck[b].id)
if (deck[b].rf==NULL) { c=changes=1; deck[b].id++; break; }
else if (deck[a].rf==NULL) { c=changes=1; deck[a].id++; break; }
else { box3 << "Duplicate memo #" << deck[a].id << '.' << endl;
errors|=1; break; } } if (a<decksize-1) break; } while (c);
for (a=0; a<decksize; a++) // check for self refs or wild refs
for (q=deck[a].rf; q!=NULL; q=q->n) // each ref of each note
{ if (q->r==deck[a].id) { q->r=0; changes=1; } // self ref
for (b=0; b<decksize; b++) if (q->r==deck[b].id) break;
if (b==decksize) { q->r=0; changes=1; } } // wild ref
if (errors) // 1=minor, 2=major
{ box4 << endl << "Errors found. Press any key to continue.";
bioskey (0); } }
/***/void putmemos (char *fn, int c)
{ int a, b; line *s; ref *q;
directvideo=0; if (errors>1) // 1=minor, 2=major
{ box4 << endl << "File format errors, file not written."; return; }
if (changes) if (c) do { box4 << endl << "Save changes? Y/N: ";
a=bioskey(0); if (tolower(a)=='n') return; }
while (tolower(a)!='y'); else;
else { if (!c) box4 << endl << "No changes."; return; }
ofstream fout (fn); if (fout.fail ()) // no file
{ box4 << endl << "Cannot create " << fn; return; }
fout << "<memos>" << endl;
for (b=0; b<decksize; b++) { a=seq[b];
if (deck[a].hd==NULL && deck[a].bd==NULL && !refcount (b)) continue;
fout << "<memo#" << deck[a].id << '>';
if (deck[a].hd!=NULL) fout << deck[a].hd;
fout << endl; // end of header line
for (s=deck[a].bd; s!=NULL; s=s->n) fout << s->t << endl;
if (deck[a].rf!=NULL) fout << "<refs>" << endl;
for (q=deck[a].rf; q!=NULL; q=q->n) if (q->r) fout << q->r << endl;
fout << "</memo#" << deck[a].id << '>' << endl; }
fout << "</memos>" << endl;
box4 << endl << "Data saved."; changes=0; }
/***/void drawscreen ()
{ int a;
box1.window (1, 1, 80, 25); // outer window
box1.clrscr(); box1.rdbuf()->gotoxy (1, 2);
directvideo=1; for (a=0; a<80; a++) box1.put(char (205));
box1.rdbuf()->gotoxy (1, 23);
for (a=1; a<80; a++) box1.put(char (205));
box2.window (1, 1, 80, 1); // key field
box3.window (1, 3, 80, 22); // body field
box4.window (1, 24, 80, 24); // prompts and messages
}
/***/int showindex ()
{ int a, b; unsigned key; ref *q, *r; line *s, *t;
static int base=0;
directvideo=1;
box1.rdbuf()->gotoxy (1, 25); for (a=0; a<79; a++) box1.put (' ');
box1.rdbuf()->gotoxy (7, 25); box1 << // continued on next line
"Enter=select, alt D=drop, alt M=mark, alt R=refs, alt S/X=save/exit.";
sortmemos (); box2 << endl; box2.rdbuf()->gotoxy(31, 1);
directvideo=0; box2 << "<Index of " << decksize << " memos>";
if (base>current) base=current;
else if (base+bodysize<current+1) base=current-bodysize+1;
box3.rdbuf()->gotoxy (3, (base==current? 2: 1));
redraw2 (base);
do { switch (key=bioskey (0))
{ case 19<<8: // alt r
if (showrefs ()) editnote (); key='7'; break;
case 31<<8: // alt s
key='8'; break;
case 32<<8: // alt D -- drop
directvideo=0; do { box4 << endl << "Drop this memo? Y/N: ";
key=bioskey(0); key=tolower(key); }
while (key!='y' && key!='n');
box4 << endl << "Okay"; directvideo=1;
if (key=='y') { changes=1; key='7';
delete deck[seq[current]].hd; deck[seq[current]].hd=NULL; // delete old data
for (s=deck[seq[current]].bd; s!=NULL; s=t)
{ t=s->n; delete s->t; delete s; }
deck[seq[current]].bd=NULL; deck[seq[current]].id=0;
for (q=r=deck[seq[current]].rf; q!=NULL; q=r) { r=q->n; delete q; }
deck[seq[current]].rf=NULL; break; }
box3.rdbuf()->gotoxy (3, (base==current? 2: 1));
redraw2 (base); break;
case 45<<8: // alt x
key='9'; break;
case 50<<8: // alt M -- mark
former=current; directvideo=0;
box4 << endl << "Memo marked for Copy/Link.";
directvideo=1; box3.rdbuf()->gotoxy (3, current-base+1);
break;
case 71<<8: case 71<<8 | 224: // home
redraw2 (current=base=0); break;
case 72<<8: case 72<<8 | 224: // up arrow
if (current>base) 
{ current--; box3.rdbuf()->gotoxy(3, current-base+1); }
else if (current) redraw2 (base=--current);
else beep(); break;
case 73<<8: case 73<<8 | 224: // page up
if (current>base) current=base;
else if (base>bodysize) current=base=base-bodysize;
else if (base) current=base=0; else { beep (); break; }
box3.rdbuf()->gotoxy (3, 2); redraw2 (base); break;
case 79<<8: case 79<<8 | 224: // end
current=decksize; if (decksize==maxdecksize) current--;
if (current>base+bodysize+1) base=current-bodysize+1;
redraw2 (base); break;
case 80<<8: case 80<<8 | 224: // down arrow
if (current<decksize && current<maxdecksize-1)
{ current++;
if (current+1<base+bodysize) box3.rdbuf()->gotoxy (3, current-base+1);
else redraw2 (base=current-bodysize+1); }
else beep(); break;
case 81<<8: case 81<<8 | 224: // page down
if (base+bodysize<decksize+1) current=base=base+bodysize;
else if (current<decksize) current=decksize;
else { beep (); break; }
box3.rdbuf()->gotoxy (3, (base==current? 2: 1));
redraw2 (base); break;
case 28<<8 | 13: case 224<<8 | 13: // select memo
editnote (); key='7'; break;
default: key%=(1<<8); if (key<' ' || '~'<key) { beep(); break; }
key=tolower (key);
for (current=0; current<decksize; current++)
if (key<=tolower (deck[seq[current]].hd[0])) break;
if (base>current) base=current;
else if (base+bodysize<current+1) base=current-bodysize+1;
box3.rdbuf()->gotoxy (3, (base==current? 2: 1));
redraw2 (base); key=0; break; } }
while (!isdigit (key));
return key; }
/***/void editnote ()
{ int a, code; line *s, *t; ref *q, *r;
char *p, *hd, *bd[bodysize];
directvideo=0; box2 << endl; 
hd = new char [MAXPATH];
if (deck[seq[current]].hd==NULL) *hd=0;
else { strcpy (hd, deck[seq[current]].hd); box2 << hd; }
directvideo=1; box1.rdbuf()->gotoxy (1, 25);
for (a=0; a<79; a++) box1.put (' ');
box1.rdbuf()->gotoxy (4, 25); box1 << // continued on next line
"^T=del word, ^Y/alt D=del line, alt C=copy, alt L=link, alt Q/S=quit/save.";
for (a=0; a<bodysize; a++) { bd[a] = new char [MAXPATH]; *bd[a]=0; }
 box3.clrscr();
for (a=0, s=deck[seq[current]].bd; a<bodysize && s!=NULL; a++, s=s->n)
{ strcpy (bd[a], s->t);
box3.rdbuf()->gotoxy(1, a+1); box3 << bd[a]; }
code=editor (hd, bd); if (code) // save changes
{ delete deck[seq[current]].hd; deck[seq[current]].hd=NULL; // delete old data
for (s=deck[seq[current]].bd; s!=NULL; s=t)
{ t=s->n; delete s->t; delete s; }
deck[seq[current]].bd=NULL; 
if (!deck[seq[current]].id) deck[seq[current]].id=++decksize;
if (strlen(hd)) // save head
{ deck[seq[current]].hd = new char [strlen(hd)+1];
strcpy (deck[seq[current]].hd, hd); }
for (a=0; a<bodysize; a++) // save body
{ if (strlen(bd[a])) // save only nonblank lines
{ s = new line; s->n=NULL;
s->t = new char [strlen(bd[a])+1]; strcpy(s->t, bd[a]);
t=deck[seq[current]].bd; if (t==NULL) deck[seq[current]].bd=s;
else { while (t->n!=NULL) t=t->n; t->n=s; } } }
a=deck[seq[current]].id;
if (code&(1<<4)) // copy refs
{ for (q=deck[seq[former]].rf; q!=NULL; q=q->n)
{ if (q->r==a) continue; // avoid self ref
for (r=deck[seq[current]].rf; r!=NULL && r->r!=q->r; r=r->n); // check
if (r==NULL) { r = new ref; r->r=q->r;
r->n=deck[seq[current]].rf; deck[seq[current]].rf=r; } } }
if (code&(1<<1)) // add a ref
{ for (q=deck[seq[former]].rf; q!=NULL && q->r!=a; q=q->n); // check
if (q==NULL) { q = new ref; q->r=a;
q->n=deck[seq[former]].rf; deck[seq[former]].rf=q; } } // changes saved
changes=1; }
delete hd; for (a=0; a<bodysize; a++) delete bd[a];
if (deck[seq[current]].id) former=current; }
/***/void sortmemos ()
{ int a1, a2, b1, b2, c; ref *q;
int id1=deck[seq[former]].id, id2=deck[seq[current]].id;
for (a1=0, c=0; a1<maxdecksize; a1++) seq[a1]=a1;
do { c=0; for (a1=0; a1<decksize; a1++)
{ if (deck[a1].id || deck[a1].hd!=NULL
 || deck[a1].bd!=NULL || deck[a1].rf!=NULL) continue;
for (a2=a1; a2<decksize; a2++) deck[a2]=deck[a2+1];
deck[a2].id=0; deck[a2].hd=NULL; deck[a2].bd=NULL; deck[a2].rf=NULL;
decksize--; changes=c=1; } } while (c);
for (a1=0; a1<decksize-1; a1++) for (b1=a1+1; b1<decksize; b1++)
{ a2=seq[a1]; b2=seq[b1];
if (deck[b2].hd==NULL) continue;
if (deck[a2].hd==NULL) { seq[a1]=b2; seq[b1]=a2; c=1; }
else if (stricmp (deck[a2].hd, deck[b2].hd)>0)
{ seq[a1]=b2; seq[b1]=a2; c=1; } }
changes|=c; if (changes) { // renumber id and refs
former=maxdecksize; for (a1=0; a1<decksize; a1++)
{ if (id1==deck[seq[a1]].id) former=a1;
 if (id2==deck[seq[a1]].id) current=a1; }
for (a1=0; a1<decksize; a1++) { deck[a1].id+=maxdecksize;
for (q=deck[a1].rf; q!=NULL; q=q->n) if (q->r) q->r+=maxdecksize; }
for (a1=0; a1<decksize; a1++) { a2=seq[a1];
b2=deck[a2].id; deck[a2].id=a1+1;
for (b1=0; b1<decksize; b1++) for (q=deck[b1].rf; q!=NULL; q=q->n)
if (q->r==b2) q->r=a1+1; } } }
/***/int editor (char *head, char **body)
{ int a, b, c, k, l, nh1, nh2, upper, xh, xw, x, y;
unsigned ans, key; line *pl; char *pc;
c=nh1=nh2=upper=0; box3.rdbuf()->gotoxy (x=1, y=1);
directvideo=1;
do { box2.rdbuf()->gotoxy (73, 1); // show mode
if (upper) { box2 << "<HEAD>"; box2.rdbuf()->gotoxy (xh, 1); }
else { box2 << "<BODY>"; box3.rdbuf()->gotoxy (x, y); }
key=bioskey (0); // get next keystroke
if (key==(71<<8) || key==(71<<8|224)) { nh1++; nh2=0; } // home
else if (key==(79<<8) || key==(79<<8|224)) { nh1=0; nh2++; } // end
else nh1=nh2=0; switch (key) {
case 14<<8 | 8: // backspace
if (upper) { if (xh==1) { beep(); break; }
if ((xh-1)<=strlen (head)) // delete char
{ xh--; strcpy (head+xh-1, head+xh); box2.rdbuf()->gotoxy (xh, 1);
box2 << head+xh-1 << ' ';
box2.rdbuf()->gotoxy (xh, 1); c|=1; } break; }
if (x==1) { beep(); break; }
if ((x-1)<=strlen (body[y-1])) // delete char
{ x--; strcpy (body[y-1]+x-1, body[y-1]+x); box3.rdbuf()->gotoxy (x, y);
box3 << body[y-1]+x-1 << ' '; box3.rdbuf()->gotoxy (x, y); c|=1; }
break;
case 28<<8 | 13: case 224<<8 | 13: // enter
if (upper) { head[xh-1]=0; box2 << endl << head;
box3.rdbuf()->gotoxy (x=1, y=1); upper=0; c|=1; break; }
if (y<bodysize && strlen (body[y-1])) // okay to go down
{ for (a=bodysize-1; a>y; a--) strcpy (body[a], body[a-1]);
strcpy (body[y], body[y-1]+x-1); body[y-1][x-1]=0;
redraw1 (body, x=1, ++y); c|=1; }
else beep(); break;
case 20<<8 | 20: // ^T -- delete a word
if (upper) { if (xh>=strlen (head) || isspace (head[xh-1])) { beep(); break; }
while (head[xh-1] && !isspace (head[xh-1])) strcpy (head+xh-1, head+xh);
while (head[xh-1] && isspace (head[xh-1])) strcpy (head+xh-1, head+xh);
box2 << endl << head; c|=1; break; }
a=strlen (body[y-1]);
if (x>=a || isspace (body[y-1][x-1])) { beep(); break; }
while (body[y-1][x-1] && !isspace (body[y-1][x-1]))
strcpy (body[y-1]+x-1, body[y-1]+x);
while (body[y-1][x-1] && isspace (body[y-1][x-1]))
strcpy (body[y-1]+x-1, body[y-1]+x);
b=strlen(body[y-1]); box3.rdbuf()->gotoxy (1, y);
box3 << body[y-1]; while (b<a) { box3.put (' '); b++; }
box3.rdbuf()->gotoxy (x, y); break;
case 31<<8: break; // alt S
case 21<<8 | 25: case 32<<8: // ^Y, alt D -- delete a line
if (upper) { box2 << endl; xh=1; head[0]=0; c|=1; break; }
if (y<bodysize) for (a=y-1; a<bodysize-1; a++) strcpy (body[a], body[a+1]);
body[bodysize-1][0]=0; redraw1 (body, x=1, y); c|=1;
break;
case 38<<8: // alt L, link memos
directvideo=0; if (former==current || former==maxdecksize)
box4 << endl << "No former note to link to.";
else { pc=deck[seq[former]].hd;
do { box4 << endl << "Link to \"";
if (pc!=NULL && *pc) box4 << pc;
else box4 << '#' << deck[former].id << ". <UNTITLED>";
box4 << "\"? Y/N: ";
ans=bioskey(0); ans=tolower(ans); }
while (ans!='y' && ans!='n');
if (ans=='y') c|=(1<<1); box4 << endl << "Okay"; }
directvideo=1; break;
case 16<<8: return 0; // alt Q, quit
case 46<<8: // alt C -- copy
directvideo=0; if (former==current || former==maxdecksize)
box4 << endl << "No former note to copy from.";
else { pc=deck[seq[former]].hd;
do { box4 << endl << "Copy from \"";
if (pc!=NULL && *pc) box4 << pc;
else box4 << '#' << deck[former].id << ". <UNTITLED>";
box4 << "\"? Y/N: ";
ans=bioskey(0); ans=tolower(ans); }
while (ans!='y' && ans!='n');
if (ans=='n') box4 << endl << "Okay";
else { k=(pc==NULL? 0: strlen (pc));
for (l=0, pl=deck[seq[former]].bd; pl!=NULL; pl=pl->n) l++;
if (!k && !l && deck[seq[former]].rf==NULL)
box4 << endl << "Nothing to copy.";
else { if (k) { box4 << endl << "Copy Head? (Y/N): "; ans=bioskey (0);
if (tolower (ans)=='y')
if (k+strlen (head)>maxheader) beep ();
else { strcat (head, pc); c|=(1<<2); } }
for (b=0; b<bodysize && body[b][0]; b++); // count lines
if (l) { box4 << endl << "Copy Body? (Y/N): "; ans=bioskey (0);
if (tolower (ans)=='y')
if (b+l>=bodysize) beep ();
else { for (pl=deck[seq[former]].bd; pl!=NULL; pl=pl->n)
strcpy (body[b++], pl->t);
c|=(1<<3); } }
if (deck[seq[former]].rf!=NULL)
{ box4 << endl << "Copy Refs? (Y/N): "; ans=bioskey (0);
if (tolower (ans)=='y') c|=(1<<4); }
} }
box4 << endl << "Okay"; } directvideo=1;
if (c&(1<<2)) box2 << endl << head;
if (c&(1<<3)) redraw1 (body, x, y); break;
case 71<<8: case 71<<8 | 224: // home
if (upper) { box2.rdbuf()->gotoxy (xh=1, 1); break; }
if (nh1==2) y=1; if (nh1==1 || nh1==2)
{ box3.rdbuf()->gotoxy (x=1, y); break; }
upper=1; box2.rdbuf()->gotoxy (xh=1, 1);
break;
case 72<<8: case 72<<8 | 224: // up arrow
if (upper) { beep(); break; } // ignore this
if (y>1) { y--; if (x>(a=strlen (body[y-1])+1)) x=a;
box3.rdbuf()->gotoxy (x, y); break; }
upper=1; box2.rdbuf()->gotoxy (xh=1, 1);
break;
case 75<<8: case 75<<8 | 224: // left arrow
if (upper) { if (xh>1) box2.rdbuf()->gotoxy (--xh, 1);
else beep(); break; }
if (x>1) box3.rdbuf()->gotoxy (--x, y);
else beep(); break;
case 77<<8: case 77<<8 | 224: // right arrow
if (upper) { if (xh<=strlen (head)) // okay to move
box2.rdbuf()->gotoxy (++xh, 1); else beep(); break; }
if (x<=strlen (body[y-1])) box3.rdbuf()->gotoxy (++x, y);
else beep(); break;
case 79<<8: case 79<<8 | 224: // end
if (upper) { if (nh2==1) // to end of header
{ box2.rdbuf()->gotoxy (xh=strlen (head)+1, 1); break; }
box3.rdbuf()->gotoxy (x=1, y=1); upper=nh2=0; break; }
if (nh2==1) { box3.rdbuf()->gotoxy (x=strlen (body[y-1])+1, y); break; }
for (a=0; a<bodysize; a++) if (strlen (body[bodysize-a-1])) break;
x=(a? 1: strlen (body[bodysize-1])+1);
y=(a? bodysize-a+1: bodysize); box3.rdbuf()->gotoxy (x, y);
break;
case 80<<8: case 80<<8 | 224: // down arrow
if (upper) { box3.rdbuf()->gotoxy (x=1, y=1); upper=0; break; }
if (y<bodysize && strlen (body[y-1])) // okay to go down
{ y++; if (x>(a=strlen (body[y-1])+1)) x=a;
box3.rdbuf()->gotoxy (x, y); }
else beep(); break;
case 83<<8: case 83<<8 | 224: // delete char
if (upper) { if (xh<(strlen (head)+1)) // okay to delete char
{ strcpy (head+xh-1, head+xh); box2.rdbuf()->gotoxy (xh, 1);
box2 << head+xh-1 << ' '; box2.rdbuf()->gotoxy (xh, 1); c|=1; }
else beep(); break; }
if (x<(a=strlen (body[y-1])+1)) // okay to delete char
{ strcpy (body[y-1]+x-1, body[y-1]+x); box3.rdbuf()->gotoxy (x, y);
box3 << body[y-1]+x-1 << ' '; box3.rdbuf()->gotoxy (x, y); c|=1; }
else if (y<bodysize) { joinlines (body, x, y); c|=1; }
else beep(); break;
case 115<<8: case 115<<8 | 224: // ctrl-left
if (upper) { if (xh==1) { beep(); break; }
k=xh; b=(isspace (head[k-2])? 0: 1);
while (b==0 && k>1) if (isspace (head[k-2])) k--; else b=1;
while (b==1 && k>1) if (isspace (head[k-2])) b=2; else k--;
box2.rdbuf()->gotoxy (xh=k, 1); if (b==0) beep(); break; }
if (x==1 && y==1) { beep(); break; }
k=x; l=y; if (k==1) { l--; k=strlen (body[l-1]); }
b=(isspace (body[y-1][k-2])? 0: 1);
while (b==0 && k>1) if (isspace (body[l-1][k-2])) k--; else b=1;
while (b==1 && k>1) if (isspace (body[l-1][k-2])) b=2; else k--;
box3.rdbuf()->gotoxy (x=k, y=l); if (b==0) beep();
break;
case 116<<8: case 116<<8 | 224: // ctrl-right
if (upper) { if (xh>=(a=strlen (head))) { beep(); break; }
k=xh; b=(isspace (head[k-1])? 1: 0);
while (b==0 && k<=a) if (isspace (head[k-1])) b=1; else k++;
while (b==1 && k<=a) if (isspace (head[k-1])) k++; else b=2;
box2.rdbuf()->gotoxy (xh=k, 1); if (b<2) beep(); break; }
if (!(a=strlen (body[y-1])) || (x>=a && y==bodysize)) { beep(); break; }
k=x; l=y; if (k>=a) { l++; k=1; a=strlen (body[l-1]); }
b=(isspace (body[l-1][k-1])? 1: ((k==1 && l>y)? 2: 0));
while (b==0 && k<=a) if (isspace (body[l-1][k-1])) b=1; else k++;
while (b==1 && k<=a) if (isspace (body[l-1][k-1])) k++; else b=2;
box3.rdbuf()->gotoxy (x=k, y=l); if (b<2) beep();
break;
default: key%=(1<<8); if (key<32 || key>'~') { beep(); break; }
if (upper) { a=strlen (head)+1; if (xh<maxheader && a<maxheader)
{ if (xh<a) for (b=a; b>=xh; b--) head[b]=head[b-1];
head[xh-1]=key; head[a]=0; box2 << head+xh-1;
box2.rdbuf()->gotoxy (++xh, 1); c|=1; }
else beep(); break; } // end of upper
if ((strlen (body[y-1])+2)>=MAXPATH) // time to wrap
{ if (!(xw=wordwrap (body, x, y))) { beep(); break; } // char lost
if (xw!=x) y++; redraw1 (body, x=xw, y); }
if (x<(a=strlen (body[y-1])+1))
for (b=a; b>=x; b--) body[y-1][b]=body[y-1][b-1];
body[y-1][x-1]=key; body[y-1][a]=0; box3 << body[y-1]+x-1;
box3.rdbuf()->gotoxy (++x, y); c|=1; break; }
} while (key!=31<<8); // alt s
return c; }
/***/void beep ()
{ sound(880); delay(100); nosound(); }
/***/void joinlines (char **body, int x, int y)
{ int a, b, c; char *p;
a=strlen (body[y-1]);
if (a && body[y-1][a-1]!=' ') { body[y-1][a]=' '; body[y-1][++a]=0; }
while (body[y][0]==' ') strcpy (body[y], body[y]+1);
while ((p=strstr (body[y], "  "))!=NULL) strcpy (p, p+1);
b=strlen (body[y]);
if ((a+b+1)<MAXPATH) { strcat (body[y-1], body[y]);
for (a=y; a<bodysize-1; a++) strcpy (body[a], body[a+1]);
body[bodysize-1][0]=0; } // end of first option
else { for (c=b; c; c--) if (body[y][c]==' ' && (a+c+1)<MAXPATH) break;
if (c) { body[y][c]=0; strcat (body[y-1], body[y]);
strcpy (body[y], body[y]+c+1); } } redraw1 (body, x, y); }
/***/int wordwrap (char **body, int x, int y)
{ int a, b, c, d, l;
if (y==bodysize) return 0; // failure
a=strlen (body[y-1]); // source line
while (isspace (body[y-1][a-1])) body[y-1][--a]=0;
for (b=a; b; b--) if (isspace (body[y-1][b])) break;
c=strlen (body[y]); // destination line
l=a-b; // to be moved
while ((c+l+3)>MAXPATH) // wrap the next line
{ if (!wordwrap (body, c, y+1)) return 0; c=strlen (body[y]); }
for (d=c; d>=0; d--) body[y][d+l]=body[y][d];
for (d=0; d<l; d++) body[y][d]=body[y-1][b+d+1];
body[y][l-1]=' '; body[y-1][b]=0;
return (x<b+2? x: x-b-1); }
/***/void redraw1 (char **body, int x, int y)
{ int a;
directvideo=1; box3.clrscr(); for (a=0; a<bodysize; a++)
{ box3.rdbuf()->gotoxy (1, a+1); box3 << body[a]; }
box3.rdbuf()->gotoxy (x, y); }
/***/void redraw2 (int base) // display index list
{ int a; int y=current-base+1;
int y0=box3.rdbuf()->wherey();
directvideo=1; box3.clrscr();
for (a=0; a<bodysize && a+base<decksize+1 && a+base<maxdecksize; a++)
{ box3.rdbuf()->gotoxy (3, a+1);
if (a+base==decksize)
box3 << "#" << decksize+1 << ". <NEW ENTRY>";
else box3 << "#" << deck[seq[a+base]].id << ". " <<
 (deck[seq[a+base]].hd==NULL? "<UNTITLED>": deck[seq[a+base]].hd); }
box3.rdbuf()->gotoxy(3, y); if (y0==y) return;
directvideo=0;
if (current==decksize)
box3 << "#" << decksize+1 << ". <NEW ENTRY>";
else box3 << "#" << deck[seq[current]].id << ". " <<
 (deck[seq[current]].hd==NULL? "<UNTITLED>": deck[seq[current]].hd);
directvideo=1; box3.rdbuf()->gotoxy(3, y); }
/***/int showrefs ()
{ int a, base, y; unsigned key;
char *p=deck[seq[current]].hd;
ref *q=deck[seq[current]].rf, *r;
int max=refcount (current);
directvideo=0; if (q==NULL || !max)
{ box4 << endl << "No references found.";
directvideo=1; return 0; }
box2 << endl << "Refs=" << max
 << " for \"" << (p==NULL? "<UNTITLED>": p) << '"';
directvideo=1;
box2.rdbuf()->gotoxy (73, 1); box2 << "<REFS>";
box1.rdbuf()->gotoxy (1, 25); for (a=0; a<79; a++) box1.put (' ');
box1.rdbuf()->gotoxy (21, 25); box1 << // continued on next line
"Enter=select, alt D=del ref, alt X=exit.";
box3.rdbuf()->gotoxy (3, 2);
redraw3 (q, base=0, y=1);
do { switch (key=bioskey (0))
{ case 32<<8: // alt D -- delete ref
while (y>1) { if (q->r) a--; q=q->n; }
q->r=0; changes=1; max=refcount (current);
if (!max)
{ directvideo=0; box4 << endl << "Last reference deleted.";
directvideo=1; return 0; }
box3.rdbuf()->gotoxy (3, 2);
redraw3 (q=deck[seq[current]].rf, base=0, y=1);
break;
case 16<<8: case 31<<8: key=45<<8; // alt Q/S set to alt X
case 45<<8: break; // alt X -- exit
case 28<<8 | 13: case 224<<8 | 13: // enter
while (y>1) { if (q->r) y--; q=q->n; }
for (a=0; a<decksize; a++) if (q->r==deck[seq[a]].id) // found it
{ current=a; break; } return 1;
case 71<<8: case 71<<8 | 224: // home
redraw3 (q, base=0, y=1); break;
case 72<<8: case 72<<8 | 224: // up arrow
if (y>base+1)  box3.rdbuf()->gotoxy(3, --y);
else if (base) redraw3 (q, --base, y=1);
else beep(); break;
case 79<<8: case 79<<8 | 224: // end
if (max<=bodysize) redraw3 (q, base=0, y=max);
else redraw3 (q, base=max-bodysize, y=bodysize);
break;
case 80<<8: case 80<<8 | 224: // down arrow
if (max>y+base) if (y<decksize)
box3.rdbuf()->gotoxy (3, ++y);
else redraw3 (q, ++base, y);
else beep (); break;
default: beep(); break; } }
while (key!=45<<8); return 0; }
/***/void redraw3 (ref *rf, int base, int y)
{ int a, b, r0; char *p, *p0; ref *q;
int y0=box3.rdbuf()->wherey(); r0=0; p0=NULL;
box3.clrscr ();
for (a=0, q=rf; a+base<bodysize && q!=NULL; q=q->n)
{ if (!q->r) continue; if (a++<base) continue;
for (b=0; b<decksize; b++) if (q->r==deck[seq[b]].id) // found it
{ p=deck[seq[b]].hd;
if (y==a-base) { r0=q->r; p0=p; }
box3.rdbuf()->gotoxy (3, a-base);
box3 << "Ref #" << a << ". to \"";
if (p!=NULL && *p) box3 << p << '"';
else box3 << '#' << q->r << ". <UNTITLED>\""; break; } }
box3.rdbuf()->gotoxy(3, y); if (y==y0) return;
directvideo=0;
box3 << "Ref #" << y+base << ". to \"";
if (p0!=NULL && *p0) box3 << p0 << '"';
else box3 << '#' << r0 << ". <UNTITLED>\"";
directvideo=1; box3.rdbuf()->gotoxy(3, y); }
/***/int refcount (int a)
{ int b; ref *q;
for (b=0, q=deck[seq[a]].rf; q!=NULL; q=q->n) if (q->r) b++;
return b; }

